• Codeforces Round #669 ABC 题解


    A. Ahahahahahahahaha

    题意:给个一个偶数长度的01序列,要求删除不超过2/n个元素使得奇数位和等于偶数位和。

    思路:注意到题目给的提示,只有0和1,且为偶数长度。
    那么对和有贡献的也就只有1,而且0或1总有一个出现次数小于等于n/2。
    所以我们就有这样的策略,把最后搞的只剩0或者1即可,0的个数小就删0,反之删1。
    最后注意只保留1的时候还要考虑一下答案数组长度的奇偶性。

    view code
    #include<iostream>
    #include<string>
    #include<algorithm>
    #include<cstdio>
    #include<cstring>
    #include<cmath>
    #include<map>
    #include <queue>
    #include<sstream>
    #include <stack>
    #include <set>
    #include <bitset>
    #include<vector>
    #define FAST ios::sync_with_stdio(false)
    #define abs(a) ((a)>=0?(a):-(a))
    #define sz(x) ((int)(x).size())
    #define all(x) (x).begin(),(x).end()
    #define mem(a,b) memset(a,b,sizeof(a))
    #define max(a,b) ((a)>(b)?(a):(b))
    #define min(a,b) ((a)<(b)?(a):(b))
    #define rep(i,a,n) for(int i=a;i<=n;++i)
    #define per(i,n,a) for(int i=n;i>=a;--i)
    #define pb push_back
    #define mp make_pair
    #define fi first
    #define se second
    using namespace std;
    typedef long long ll;
    typedef pair<ll,ll> PII;
    const int maxn = 1e5+200;
    const int inf=0x3f3f3f3f;
    const double eps = 1e-7;
    const double pi=acos(-1.0);
    const int mod = 1e9+7;
    inline int lowbit(int x){return x&(-x);}
    ll gcd(ll a,ll b){return b?gcd(b,a%b):a;}
    void ex_gcd(ll a,ll b,ll &d,ll &x,ll &y){if(!b){d=a,x=1,y=0;}else{ex_gcd(b,a%b,d,y,x);y-=x*(a/b);}}//x=(x%(b/d)+(b/d))%(b/d);
    inline ll qpow(ll a,ll b,ll MOD=mod){ll res=1;a%=MOD;while(b>0){if(b&1)res=res*a%MOD;a=a*a%MOD;b>>=1;}return res;}
    inline ll inv(ll x,ll p){return qpow(x,p-2,p);}
    inline ll Jos(ll n,ll k,ll s=1){ll res=0;rep(i,1,n+1) res=(res+k)%i;return (res+s)%n;}
    inline ll read(){ ll f = 1; ll x = 0;char ch = getchar();while(ch>'9'||ch<'0') {if(ch=='-') f=-1; ch = getchar();}while(ch>='0'&&ch<='9') x = (x<<3) + (x<<1) + ch - '0',  ch = getchar();return x*f; }
    int dir[4][2] = { {1,0}, {-1,0},{0,1},{0,-1} };
    
    ll a[maxn];
    ll n;
    
    
    int main()
    {
        int kase;
        cin>>kase;
        while(kase--)
        {
            vector<ll> ans;
            n = read();
            rep(i,1,n) a[i] = read();
            ll sum = 0;
            rep(i,1,n) sum += a[i];
            if(sum > n/2)
            {
                rep(i,1,n) if(a[i]==1) ans.pb(a[i]);
                if(ans.size()&1)
                {
                    ans.pop_back();
                }
            }
            else rep(i,1,n) if(a[i]==0) ans.pb(a[i]);
            if(ans.size()==1) ans[0] = 0;
            cout<<ans.size()<<'
    ';
            for(int i=0; i<ans.size(); i++) cout<<ans[i]<<' ';
            cout<<'
    ';
        }
        return 0;
    }
    
    

    B. Big Vova

    题意:给一个a数组,问你构造一个b序列,使得存在c序列,其中c[i] = gcd(b[1],b[2],...,b[i]),且c的字典序最大。

    思路:贪心,第一个肯定是最大的那个元素。然后每次暴力枚举出下一位能放的产生gcd最大的那个即可。

    view code
    #include<iostream>
    #include<string>
    #include<algorithm>
    #include<cstdio>
    #include<cstring>
    #include<cmath>
    #include<map>
    #include <queue>
    #include<sstream>
    #include <stack>
    #include <set>
    #include <bitset>
    #include<vector>
    #define FAST ios::sync_with_stdio(false)
    #define abs(a) ((a)>=0?(a):-(a))
    #define sz(x) ((int)(x).size())
    #define all(x) (x).begin(),(x).end()
    #define mem(a,b) memset(a,b,sizeof(a))
    #define max(a,b) ((a)>(b)?(a):(b))
    #define min(a,b) ((a)<(b)?(a):(b))
    #define rep(i,a,n) for(int i=a;i<=n;++i)
    #define per(i,n,a) for(int i=n;i>=a;--i)
    #define pb push_back
    #define mp make_pair
    #define fi first
    #define se second
    using namespace std;
    typedef long long ll;
    typedef pair<ll,ll> PII;
    const int maxn = 1e5+200;
    const int inf=0x3f3f3f3f;
    const double eps = 1e-7;
    const double pi=acos(-1.0);
    const int mod = 1e9+7;
    inline int lowbit(int x){return x&(-x);}
    ll gcd(ll a,ll b){return b?gcd(b,a%b):a;}
    void ex_gcd(ll a,ll b,ll &d,ll &x,ll &y){if(!b){d=a,x=1,y=0;}else{ex_gcd(b,a%b,d,y,x);y-=x*(a/b);}}//x=(x%(b/d)+(b/d))%(b/d);
    inline ll qpow(ll a,ll b,ll MOD=mod){ll res=1;a%=MOD;while(b>0){if(b&1)res=res*a%MOD;a=a*a%MOD;b>>=1;}return res;}
    inline ll inv(ll x,ll p){return qpow(x,p-2,p);}
    inline ll Jos(ll n,ll k,ll s=1){ll res=0;rep(i,1,n+1) res=(res+k)%i;return (res+s)%n;}
    inline ll read(){ ll f = 1; ll x = 0;char ch = getchar();while(ch>'9'||ch<'0') {if(ch=='-') f=-1; ch = getchar();}while(ch>='0'&&ch<='9') x = (x<<3) + (x<<1) + ch - '0',  ch = getchar();return x*f; }
    int dir[4][2] = { {1,0}, {-1,0},{0,1},{0,-1} };
    
    ll n;
    ll a[maxn];
    ll vis[1005];
    
    
    int main()
    {
        int kase;
        cin>>kase;
        while(kase--)
        {
            vector<ll> ans;
            mem(vis,0);
            ll n = read();
            rep(i,1,n) a[i] = read();
            sort(a+1,a+1+n);
            ll m = a[n];
            ans.pb(m);
            ll cnt = 1;
            while(cnt<n)
            {
                ll ma = 0, pos = 0;
                per(i,n-1,1) if(!vis[i]&&gcd(a[i],m)>ma||(!vis[i]&&gcd(a[i],m)==ma&&a[pos]>a[i])) ma = gcd(a[i],m), pos = i;
                cnt++;
                ans.pb(a[pos]);
                m = ma;
                vis[pos] = 1;
        }
        rep(i,1,n) cout<<ans[i-1]<<' ';
        cout<<'
    ';
        }
        return 0;
    }
    
    

    C. Chocolate Bunny

    题意:交互题,有一个n排列(没告诉你长什么样),你每次可以问它p[i]%p[j]的结果,然后他会告诉你这个值。让你在不超过2n的询问下把这个序列求出来。

    思路:第一次做交互题刚开始有点蒙圈
    其实想到一个点就可以立马A掉了。我们用双指针从头尾两端开始遍历。每次询问两个,(p,q)和(q,p),因为肯定要么是a[p] > a[q] 要么是a[q] > a[p],所以结果肯定一个等于两者之间的最小值,一个是比这个最小值要小。所以我们每两次询问都能得到一个a[p]或a[q],然后移动指针即可。如2%5 和 5%2 ,分别是2和1,所以a[p]肯定是2。
    具体详见代码。

    view code
    #include<iostream>
    #include<string>
    #include<algorithm>
    #include<cstdio>
    #include<cstring>
    #include<cmath>
    #include<map>
    #include <queue>
    #include<sstream>
    #include <stack>
    #include <set>
    #include <bitset>
    #include<vector>
    #define FAST ios::sync_with_stdio(false)
    #define abs(a) ((a)>=0?(a):-(a))
    #define sz(x) ((int)(x).size())
    #define all(x) (x).begin(),(x).end()
    #define mem(a,b) memset(a,b,sizeof(a))
    #define max(a,b) ((a)>(b)?(a):(b))
    #define min(a,b) ((a)<(b)?(a):(b))
    #define rep(i,a,n) for(int i=a;i<=n;++i)
    #define per(i,n,a) for(int i=n;i>=a;--i)
    #define pb push_back
    #define mp make_pair
    #define fi first
    #define se second
    using namespace std;
    typedef long long ll;
    typedef pair<ll,ll> PII;
    const int maxn = 1e5+200;
    const int inf=0x3f3f3f3f;
    const double eps = 1e-7;
    const double pi=acos(-1.0);
    const int mod = 1e9+7;
    inline int lowbit(int x){return x&(-x);}
    ll gcd(ll a,ll b){return b?gcd(b,a%b):a;}
    void ex_gcd(ll a,ll b,ll &d,ll &x,ll &y){if(!b){d=a,x=1,y=0;}else{ex_gcd(b,a%b,d,y,x);y-=x*(a/b);}}//x=(x%(b/d)+(b/d))%(b/d);
    inline ll qpow(ll a,ll b,ll MOD=mod){ll res=1;a%=MOD;while(b>0){if(b&1)res=res*a%MOD;a=a*a%MOD;b>>=1;}return res;}
    inline ll inv(ll x,ll p){return qpow(x,p-2,p);}
    inline ll Jos(ll n,ll k,ll s=1){ll res=0;rep(i,1,n+1) res=(res+k)%i;return (res+s)%n;}
    inline ll read(){ ll f = 1; ll x = 0;char ch = getchar();while(ch>'9'||ch<'0') {if(ch=='-') f=-1; ch = getchar();}while(ch>='0'&&ch<='9') x = (x<<3) + (x<<1) + ch - '0',  ch = getchar();return x*f; }
    int dir[4][2] = { {1,0}, {-1,0},{0,1},{0,-1} };
    
    ll a[maxn];
    ll vis[maxn];
    
    
    int main()
    {
        ll n = read();
        int p = 1, q = n;
        int cnt = 0;
        while(cnt<=n-1&&p<q)
        {
            printf("? %d %d
    ", p, q);
            fflush(stdout);
            ll r1 = read();
            printf("? %d %d
    ", q, p);
            fflush(stdout);
            ll r2 = read();
            if(r1 > r2) a[p] = r1, p++,vis[r1]=1;
            else a[q] = r2, q--, vis[r2]=1;
            cnt++;
        }
        ll sum = (1+n)*n/2;
        ll all = 0;
        rep(i,1,n) all += a[i];
        rep(i,1,n) if(a[i]==0) a[i] = sum - all;
        printf("! ");
        rep(i,1,n) printf("%lld%c",a[i], i==n?'
    ':' ');
        fflush(stdout);
        return 0;
    }
    
    
  • 相关阅读:
    【转】C#中判断扫描枪输入与键盘输入
    根据名称分组,选择最大日期和最小日期的数据,并显示在一行上
    C#如何判断我的程序已经有一个实例正在运行
    消息队列篇
    Redis面试笔记(二)雪崩、穿透、击穿三连问
    MySQL基础
    Redis面试笔记(一)
    Java多线程(二)
    Java多线程(一)
    Elastic Search之布尔查询
  • 原文地址:https://www.cnblogs.com/Bgwithcode/p/13636645.html
Copyright © 2020-2023  润新知